/**

 * Plugin Name: StPays

 * Plugin URI:

 * Description: Official StPays plugin.

 * Version: 2.0.3

 * Author: StPays Srl

 * Author URI: https://www.stpays.it

 * Text Domain: stpays

 * Domain Path: /lang

 *

 * Copyright: © 2017-2018, Nexi SpA

 * License: GNU General Public License v3.0

 * License URI: http://www.gnu.org/licenses/gpl-3.0.html

 */
var xpayConfig;

var card;

var buttons;


jQuery(document).ajaxComplete(function(event, xhr, settings) {
    if (settings.url === '/?wc-ajax=apply_coupon' || settings.url === '/?wc-ajax=remove_coupon') {
        location.reload();
    }
});


jQuery(document).ready(function() {

    
});
// jQuery('document').find('#place_order').attr('disabled',true);



function installmentsCalc() {

    // jQuery("#stpays-installments-number").select2({

    //   placeholder: 'Select an option'

    // });

    // jQuery("#stpays-periodicity-number").select2({

    //   placeholder: 'Select an option'

    // });

    jQuery("#stpays-intallment-info").addClass('stpays-loading');

    jQuery.ajax({

        type: 'POST',

        data: {

            action: 'calc_installments',

            installments: jQuery("#stpays-installments-number").val(),

            periodicity: jQuery("#stpays-periodicity-number").val()

        },

        url: myAjax.ajaxurl, //"/wordpress/wp-admin/admin-ajax.php",

        success: function(response) {

            if (document.getElementById("stpays-installments-number").value != 1) {

                jQuery("#stpays-intallment-info").html(response);

                jQuery("p#stpays-periodicity-number-title").show();

                jQuery("#stpays-periodicity-number").show();

                // jQuery("#stpays-cc-content").hide();




            } else {

                jQuery("p#stpays-periodicity-number-title").hide();

                jQuery("#stpays-periodicity-number").hide();

                jQuery("#stpays-intallment-info").html(response);



                // jQuery(".br-remove").hide();

                // CreateBuildStPays();

            }

            jQuery("#stpays-intallment-info").removeClass('stpays-loading');

        },

        complete: function() {}

    });

}



(function($) {

    var checkout_form = $('form.checkout');

    window.onload = function() {

    };

    $(document).ready(function() {



        checkout_form.on('checkout_place_order_stpays', function(e) {
            var required_fields = [];
            var required_fields_tags = jQuery('body').find('.woocommerce-checkout').find('.validate-required');

            jQuery.each(required_fields_tags, function(k, v) {
                var id = jQuery(v).find('input').attr('id');
                if (jQuery(v).parent('div').is(':visible')) {
                    if (id == undefined) {
                        id = jQuery(v).find('select').attr('id');
                    }

                    if (id == undefined) {
                        id = jQuery(v).find('checkbox').attr('id');
                    }

                    if (id != undefined) {
                        required_fields.push(id);
                    }
                }
            })

            var form_valid = true;
            jQuery.each(required_fields, function(k, v) {
                var check_value = '';

                if (v.indexOf('shipping') != -1) {
                    if ($('.shipping_address').is(':visible')) {
                        check_value = jQuery('#' + v).val();    
                    }
                }else{
                    check_value = jQuery('#' + v).val();
                }
                jQuery("#" + v + "_id").remove();

                if (check_value == '') {
                    form_valid = false;
                    var label = jQuery('#' + v).parent('span').parent('p').find('label').text();
                    label = label.split('*');
                    label = label[0].replace('&nbsp;*', '');
                    jQuery('#' + v).parent('span').append("<span style='color:red;' id='" + v + "_id'>" + label + " è obbligatorio</span>");
                }
            })
            // if ((document.getElementById("stpays-installments-number").value != 1) && (document.getElementById("stpays_accept_check").checked == false)) {

            //   document.getElementById("stpays_accept_text").style.color = "red";

            //   return false;

            // }

            // return true to continue the submission or false to prevent it return true;

            if ($('#payment_method_stpays').is(':checked')) {
                if (form_valid == true) {


                    // alert($('form.checkout input[name="stripeToken"]').val());

                    // if($('form.checkout input[name="stripeToken"]').val()!=="undefined" || $('form.checkout input[name="stripeToken"]').val()!==""){

                    //   // alert($('form.checkout input[name="stripeToken"]').val());

                    //     return true;

                    // }else{

                    // e.preventDefault();

                    if ($('#stpays-cc-content').hasClass('show-stpay-popup')) {

                        // createToken();

                        $('#stpays-cc-content').removeClass('show-stpay-popup');

                        $('.stpays-cc-content-overlay').removeClass('show-stpay-popup');

                    } else {

                        $('#stpays-cc-content').addClass('show-stpay-popup');

                        $('.stpays-cc-content-overlay').addClass('show-stpay-popup');

                        e.preventDefault();

                        return false;

                    }

                } else {
                    e.preventDefault();

                    return false;
                }

                // return false;  

                // }

            }

        });

        $(document.body).on('checkout_error', function() {

            if (($('#payment_method_stpays').is(':checked') && ('new' === $('input[name="wc-stpays-payment-token"]:checked').val() || (typeof $('input[name="wc-stpays-payment-token"]:checked').val() === 'undefined')))) {

                if ($('form.checkout input[name="stripeToken"]').val() !== "undefined" || $('form.checkout input[name="stripeToken"]').val() !== "") {

                    // $("form.checkout").trigger("update");

                    // $('#stpays_xpayNonce').val("");

                }

            }

        });



        // $('form.checkout, form#order_review, form#add_payment_method').on('change', '#wc-xpay-cc-form input', function() {

        //   $('#stpays_xpayNonce').val("");

        // });



        $(document).on('change', '#stpays-installments-number,#stpays-periodicity-number', function() {

            installmentsCalc();

            var number = document.getElementById("stpays-installments-number");

            var periodicity = document.getElementById("stpays-periodicity-number");

            var inst = document.getElementById("installments");

            if (inst) {

                inst.value = number.value;

            }

        });

        $(document).on('click', '.stpays-cc-content-close', function() {

            $('#stpays-cc-content').removeClass('show-stpay-popup');

            $('.stpays-cc-content-overlay').removeClass('show-stpay-popup');

        });



        $(document).on('click', 'button#woocommerce_stpays_place_order', function() {

            if ($('#stpays-cc-content').hasClass('show-stpay-popup')) {

                createToken();

            }

        });

    });




    // Handler per la gestione degli errori di validazione carta

    // window.addEventListener("XPay_Card_Error", function(event) {

    //   var displayError = document.getElementById("stpays_xpay-card-errors");

    //   if (event.detail.errorMessage) { // Visualizzo il messaggio di errore

    //     displayError.innerHTML = event.detail.errorMessage;



    //     if ($('#stpays_build-border-color-error').val()) {

    //       $('#stpays_xpay-card').css('border', '1px solid ' + $('#stpays_build-border-color-error').val());

    //     }

    //   } else { // Nessun errore nascondo eventuali messaggi rimasti

    //     displayError.textContent = "";



    //     if ($('#stpays_build-border-color-default').val()) {

    //       $('#stpays_xpay-card').css('border', '1px solid ' + $('#stpays_build-border-color-default').val());

    //     }

    //   }

    // });



    // Handler per ricevere nonce pagamento

    //   window.addEventListener("XPay_Nonce", function(event) {

    //     var response = event.detail;

    //     if (response.esito && response.esito === "OK") {

    //       document.getElementById("stpays_xpayNonce").setAttribute("value", response.xpayNonce);

    //       document.getElementById("stpays_xpayIdOperazione").setAttribute("value", response.idOperazione);

    //       document.getElementById("stpays_xpayTimeStamp").setAttribute("value", response.timeStamp);

    //       document.getElementById("stpays_xpayEsito").setAttribute("value", response.esito);

    //       document.getElementById("stpays_xpayMac").setAttribute("value", response.mac);



    //       form = document.getElementById('wc-stpays-cc-form');



    //       form = document.getElementById('wc-stpays-cc-form');

    //       for (var prop in response.dettaglioCarta) {

    //         document.getElementById("dettaglioCarta[" + prop + "]").setAttribute("value", '');

    //         document.getElementById("dettaglioCarta[" + prop + "]").setAttribute("value", response.dettaglioCarta[prop]);

    //       }

    //       var number = document.getElementById("stpays-installments-number");

    //       document.getElementById("installments").setAttribute("value", number.value);



    //       // Submit del form contenente il nonce verso il server del merchant

    //       document.getElementById("place_order").click();

    //     } else {

    //       // Visualizzazione errore creazione nonce e ripristino bottone form

    //       var displayError = document.getElementById("stpays_xpay-card-errors");



    //       displayError.textContent = "[" + response.errore.codice + "] " + response.errore.messaggio;



    //       document.getElementById("place_order").disabled = false;



    //       htmlErr = '<div class="woocommerce-NoticeGroup woocommerce-NoticeGroup-checkout"><ul class="woocommerce-error" role="alert"><li>' + $('#stpays_xpay_msg_err').val() + ' ' + response.errore.messaggio + '</li></ul></div>';

    //       $('form.checkout').prepend(htmlErr);

    //       $('html,body').animate({

    //         scrollTop: 0

    //       }, 'slow');

    //       jQuery('body').trigger('update_checkout');

    //     }

    //   });



}(jQuery));



// function CreateBuildStPays() {



//   // Dichiarazione variabili

//   var enviroment = document.getElementById("stpays_xpay_enviroment").value;

//   var apiKey = document.getElementById("stpays_xpay_APIKEY").value;

//   var importo = document.getElementById("stpays_xpay_amount").value;

//   var codiceTransazione = document.getElementById("stpays_xpay_transactionId").value;

//   var divisa = document.getElementById("stpays_xpay_divisa").value;

//   var timeStamp = document.getElementById("stpays_xpay_timeStamp").value;

//   var mac = document.getElementById("stpays_xpay_mac").value;

//   var url = document.getElementById("stpays_xpay_url").value;

//   var urlPost = document.getElementById("stpays_xpay_urlPost").value;

//   var urlBack = document.getElementById("stpays_xpay_urlBack").value;

//   var style = JSON.parse(document.getElementById("stpays_xpay_buildStyle").value);

//   var language = document.getElementById("stpays_xpay_language").value;



//   // Inizializzazione SDK

//   XPay.init();



//   // Configurazione del pagamento

//   xpayConfig = {

//     baseConfig: {

//       apiKey: apiKey,

//       enviroment: enviroment

//     },

//     paymentParams: {

//       amount: importo,

//       transactionId: codiceTransazione,

//       currency: divisa,

//       timeStamp: timeStamp,

//       mac: mac,

//       url: url,

//       urlPost: urlPost,

//       urlBack: urlBack

//     },

//     customParams: {},

//     language: language

//   };



//   // Configurazione SDK

//   XPay.setConfig(xpayConfig);



//   // Creazione dell elemento carta

//   card = XPay.create(XPay.OPERATION_TYPES.CARD, style);

//   card.mount("stpays_xpay-card");



// };



// function exp_check() {

//   var installments = document.getElementById('stpays-installments-number').value;

//   var exp = document.getElementById('dettaglioCarta[scadenza]').value;

//   var retAjax = null;

//   jQuery.ajax({

//     type: 'POST',

//     async: false,

//     data: {

//       action: 'exp_check',

//       installments: installments,

//       exp: exp

//     },

//     url: "/wp-admin/admin-ajax.php",

//     success: function(response) {

//       retAjax = response;

//     },

//     complete: function() {}

//   });

//   return retAjax;

// };