<?php
wp_enqueue_style('stpays_style', plugins_url('assets/css/stpays.css', plugin_dir_path(__FILE__)));
//include_once plugins_url("includes/constant_stpays.php", plugin_dir_path(__FILE__));
?>
<div id="order_xpay_details" class="panel">
    <div class="order_data_column_container">
      <?php if (isset($aDetailsOrder['brand']) || isset($aDetailsOrder['nazionalita']) || isset($aDetailsOrder['pan']) || isset($aDetailsOrder['_scadenza_pan'])) {
    ?>
        <div class="order_data_column">
            <h3><?php echo __('Card Detail', 'stpays') ?></h3>
            <p>
            <?php if (isset($aDetailsOrder['brand'])) {
        ?>
                <strong><?php echo __('Card Kind', 'stpays') ?></strong> <?php echo $aDetailsOrder['brand'] ?> <br>
                <?php
    };
    if (isset($aDetailsOrder['nazionalita'])) {
        ?>
                <strong><?php echo __('Nationality', 'stpays') ?></strong> <?php echo $aDetailsOrder['nazionalita'] ?> <br>
                <?php
    };
    if (isset($aDetailsOrder['pan'])) {
        ?>
                <strong><?php echo __('Card Pan', 'stpays') ?></strong> <?php echo $aDetailsOrder['pan'] ?> <br>
                <?php
    };
    if (isset($aDetailsOrder['_scadenza_pan'])) {
        ?>
                <strong><?php echo  __('Expire Date', 'stpays') ?></strong> <?php echo $aDetailsOrder['_scadenza_pan'] ?> <br>
                <?php
    }; ?>
            </p>
        </div>
      <?php
} ?>
    <div style="width:100%;">
    <?php if ( isset($aOrderInstallments->recurrencesSet) && count($aOrderInstallments->recurrencesSet) > 0) {
        ?>
      <h3><?php echo __('Installments Information', 'stpays'); ?></h3>
    <div class="woocommerce_subscriptions_related_orders">
        <table style="text-align: center; width: 100%;">
            <thead>
                <tr>
                  <th><?php echo __('Nr.', 'stpays') ?></th>
                  <th><?php echo __('Amount', 'stpays') ?></th>
                  <th><?php echo __('Expected Date', 'stpays') ?></th>
                  <th><?php echo __('Payment Date', 'stpays') ?></th>
                  <th><?php echo __('Paid', 'stpays') ?></th>
                </tr>
            </thead>
            <tbody>
              <?php foreach ($aOrderInstallments->recurrencesSet as $set) {
            ?>
                  <tr>
                      <td><?php echo $set->number ?></td>
                      <td><?php echo '€ ' . number_format($set->amount/100, 2, ',', '') ?></td>
                      <td><?php $expDate = new DateTime($set->expectedChargeDate);
            echo $expDate->format("d/m/Y"); ?></td>
                      <td><?php if ($set->lastChargeAttemptDate != null) {
                $actDate = new DateTime($set->lastChargeAttemptDate);
                echo $actDate->format("d/m/Y");
            } ?></td>
            <td><?php if ($set->actualChargeDate != null) {
                echo __STPAYS_ICON_OK__;
            } elseif ($set->lastChargeAttemptDate != null) {
                echo __STPAYS_ICON_KO__;
            } ?></td>
                  </tr>
              <?php
        } ?>
          </tbody>
      </table>
  </div>
</div>
<?php
    } ?>
</div>
</div>
